// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from robot_calibration_msgs:msg/Observation.idl
// generated code does not contain a copyright notice

#ifndef ROBOT_CALIBRATION_MSGS__MSG__DETAIL__OBSERVATION__TRAITS_HPP_
#define ROBOT_CALIBRATION_MSGS__MSG__DETAIL__OBSERVATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "robot_calibration_msgs/msg/detail/observation__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'features'
#include "geometry_msgs/msg/detail/point_stamped__traits.hpp"
// Member 'ext_camera_info'
#include "robot_calibration_msgs/msg/detail/extended_camera_info__traits.hpp"
// Member 'cloud'
#include "sensor_msgs/msg/detail/point_cloud2__traits.hpp"
// Member 'image'
#include "sensor_msgs/msg/detail/image__traits.hpp"

namespace robot_calibration_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Observation & msg,
  std::ostream & out)
{
  out << "{";
  // member: sensor_name
  {
    out << "sensor_name: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_name, out);
    out << ", ";
  }

  // member: features
  {
    if (msg.features.size() == 0) {
      out << "features: []";
    } else {
      out << "features: [";
      size_t pending_items = msg.features.size();
      for (auto item : msg.features) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: ext_camera_info
  {
    out << "ext_camera_info: ";
    to_flow_style_yaml(msg.ext_camera_info, out);
    out << ", ";
  }

  // member: cloud
  {
    out << "cloud: ";
    to_flow_style_yaml(msg.cloud, out);
    out << ", ";
  }

  // member: image
  {
    out << "image: ";
    to_flow_style_yaml(msg.image, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Observation & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: sensor_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_name: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_name, out);
    out << "\n";
  }

  // member: features
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.features.size() == 0) {
      out << "features: []\n";
    } else {
      out << "features:\n";
      for (auto item : msg.features) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: ext_camera_info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ext_camera_info:\n";
    to_block_style_yaml(msg.ext_camera_info, out, indentation + 2);
  }

  // member: cloud
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cloud:\n";
    to_block_style_yaml(msg.cloud, out, indentation + 2);
  }

  // member: image
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "image:\n";
    to_block_style_yaml(msg.image, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Observation & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace robot_calibration_msgs

namespace rosidl_generator_traits
{

[[deprecated("use robot_calibration_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const robot_calibration_msgs::msg::Observation & msg,
  std::ostream & out, size_t indentation = 0)
{
  robot_calibration_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use robot_calibration_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const robot_calibration_msgs::msg::Observation & msg)
{
  return robot_calibration_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<robot_calibration_msgs::msg::Observation>()
{
  return "robot_calibration_msgs::msg::Observation";
}

template<>
inline const char * name<robot_calibration_msgs::msg::Observation>()
{
  return "robot_calibration_msgs/msg/Observation";
}

template<>
struct has_fixed_size<robot_calibration_msgs::msg::Observation>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<robot_calibration_msgs::msg::Observation>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<robot_calibration_msgs::msg::Observation>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ROBOT_CALIBRATION_MSGS__MSG__DETAIL__OBSERVATION__TRAITS_HPP_
