// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from robot_calibration_msgs:msg/ExtendedCameraInfo.idl
// generated code does not contain a copyright notice

#ifndef ROBOT_CALIBRATION_MSGS__MSG__DETAIL__EXTENDED_CAMERA_INFO__FUNCTIONS_H_
#define ROBOT_CALIBRATION_MSGS__MSG__DETAIL__EXTENDED_CAMERA_INFO__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "robot_calibration_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "robot_calibration_msgs/msg/detail/extended_camera_info__struct.h"

/// Initialize msg/ExtendedCameraInfo message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * robot_calibration_msgs__msg__ExtendedCameraInfo
 * )) before or use
 * robot_calibration_msgs__msg__ExtendedCameraInfo__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_robot_calibration_msgs
bool
robot_calibration_msgs__msg__ExtendedCameraInfo__init(robot_calibration_msgs__msg__ExtendedCameraInfo * msg);

/// Finalize msg/ExtendedCameraInfo message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robot_calibration_msgs
void
robot_calibration_msgs__msg__ExtendedCameraInfo__fini(robot_calibration_msgs__msg__ExtendedCameraInfo * msg);

/// Create msg/ExtendedCameraInfo message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * robot_calibration_msgs__msg__ExtendedCameraInfo__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_robot_calibration_msgs
robot_calibration_msgs__msg__ExtendedCameraInfo *
robot_calibration_msgs__msg__ExtendedCameraInfo__create();

/// Destroy msg/ExtendedCameraInfo message.
/**
 * It calls
 * robot_calibration_msgs__msg__ExtendedCameraInfo__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robot_calibration_msgs
void
robot_calibration_msgs__msg__ExtendedCameraInfo__destroy(robot_calibration_msgs__msg__ExtendedCameraInfo * msg);

/// Check for msg/ExtendedCameraInfo message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_robot_calibration_msgs
bool
robot_calibration_msgs__msg__ExtendedCameraInfo__are_equal(const robot_calibration_msgs__msg__ExtendedCameraInfo * lhs, const robot_calibration_msgs__msg__ExtendedCameraInfo * rhs);

/// Copy a msg/ExtendedCameraInfo message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_robot_calibration_msgs
bool
robot_calibration_msgs__msg__ExtendedCameraInfo__copy(
  const robot_calibration_msgs__msg__ExtendedCameraInfo * input,
  robot_calibration_msgs__msg__ExtendedCameraInfo * output);

/// Initialize array of msg/ExtendedCameraInfo messages.
/**
 * It allocates the memory for the number of elements and calls
 * robot_calibration_msgs__msg__ExtendedCameraInfo__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_robot_calibration_msgs
bool
robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence__init(robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence * array, size_t size);

/// Finalize array of msg/ExtendedCameraInfo messages.
/**
 * It calls
 * robot_calibration_msgs__msg__ExtendedCameraInfo__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robot_calibration_msgs
void
robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence__fini(robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence * array);

/// Create array of msg/ExtendedCameraInfo messages.
/**
 * It allocates the memory for the array and calls
 * robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_robot_calibration_msgs
robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence *
robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence__create(size_t size);

/// Destroy array of msg/ExtendedCameraInfo messages.
/**
 * It calls
 * robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robot_calibration_msgs
void
robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence__destroy(robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence * array);

/// Check for msg/ExtendedCameraInfo message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_robot_calibration_msgs
bool
robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence__are_equal(const robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence * lhs, const robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence * rhs);

/// Copy an array of msg/ExtendedCameraInfo messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_robot_calibration_msgs
bool
robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence__copy(
  const robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence * input,
  robot_calibration_msgs__msg__ExtendedCameraInfo__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // ROBOT_CALIBRATION_MSGS__MSG__DETAIL__EXTENDED_CAMERA_INFO__FUNCTIONS_H_
